#!/usr/bin/env python
# -*- coding: utf-8 -*-

import es
from gamethread import delayed

info = es.AddonInfo()
info.name = 'AWP Traces'
info.version = '2.1.1'
info.url = 'http://addons.eventscripts.com/addons/user/43738'
info.basename = 'awp_traces'
info.author = 'maniek23'
info.description   = "Script which makes AWP sniper rifle to leave nice looking bullet traces"

addon_tag = "#default[#greenAWP Traces#default]"

model_path = "effects/gunshiptracer.vmt"

vector_1 = ""
model = None

def load():
	es.ServerVar('awp_traces_enabled', 1)
	es.ServerVar('awp_traces_time', 2)
	es.ServerVar('awp_traces_fadetime', 1)
	es.ServerVar('awp_traces_alpha', 190)
	es.ServerVar('awp_traces_speed', 1)
	es.ServerVar('awp_traces_width', 4)
	es.ServerVar('awp_traces_endwidth', 4)
	es.ServerVar('awp_traces_noise', 1)
	es.ServerVar('awp_traces_path', model_path)
	
	es.ServerVar("awp_traces", "AWP Traces by %s - v. %s" % (info.author, info.version)).makepublic()
	es.ServerVar("awp_traces_version", "%s" % info.version).makepublic()
	
	es.set('eventscripts_noisy', 1)
	
	if es.getString('eventscripts_currentmap') != "":
		global model
		model = es.precachemodel(es.getString('awp_traces_path'))
	
	es.msg('#multi', '%s Loaded' % addon_tag)
	
def unload():
	es.msg('#multi', '%s Unloaded' % addon_tag)
	
def es_map_start(ev):
	global model
	model = es.precachemodel(es.getString('awp_traces_path'))
	
def weapon_fire(ev):
	userid = int(ev['userid'])
	if int(es.ServerVar('awp_traces_enabled')) < 1 or ev['weapon'] != 'awp' or (es.exists('variable', 'mb_tracer_enabled') and es.getInt('mb_tracer_enabled') == 1):
		return
	global vector_1
	(player_x, player_y, player_z) = es.getplayerlocation(userid)
	if es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2:
		player_z += 44
	else:
		player_z += 64
		
	vector_1 = es.createvectorstring(player_x, player_y, player_z)
	
def bullet_impact(ev):
	global vector_1
	if int(es.ServerVar('awp_traces_enabled')) < 1 or vector_1 == "":
		return
	vector_2 = es.createvectorstring(float(ev['x']), float(ev['y']), float(ev['z']))
	delayed(0, es.effect, ('beam', vector_1, vector_2, model, model, 0, 0, es.getInt('awp_traces_time'), es.getInt('awp_traces_width'), es.getInt('awp_traces_endwidth'), es.getInt('awp_traces_fadetime'), es.getInt('awp_traces_noise'), 125, 125, 125, es.getInt('awp_traces_alpha'), es.getInt('awp_traces_speed')))
	delayed(0, es.effect, ('beam', vector_2, vector_1, model, model, 0, 0, es.getInt('awp_traces_time'), es.getInt('awp_traces_width') + 2, es.getInt('awp_traces_endwidth') + 4, es.getInt('awp_traces_fadetime'), 0, 255, 255, 255, es.getInt('awp_traces_alpha'), es.getInt('awp_traces_speed') + 5))

	vector_1 = ""
